freeslot("sfx_blst1", "sfx_blst2")

-- the chair
freeslot("S_MP_ROCKETCHAIR", "MT_MP_ROCKETCHAIR")
states[S_MP_ROCKETCHAIR] = {SPR_CHAI, A, -1, nil, 0, 0, S_MP_ROCKETCHAIR}
mobjinfo[MT_MP_ROCKETCHAIR] = {
	spawnstate = S_MP_ROCKETCHAIR,
	deathstate = S_NULL,
	radius = 14*FRACUNIT,
	height = 24*FRACUNIT
}

local function MP_chairKill(actor)
	if not actor.health return end
	S_StartSound(nil, sfx_blst2, actor.player)
	P_PlayerFlagBurst(actor.player)
	P_PlayerWeaponPanelBurst(actor.player)
	P_PlayerWeaponAmmoBurst(actor.player)
	P_PlayerRingBurst(actor.player)
	P_PlayerEmeraldBurst(actor.player)
	actor.player.ab_resetmusiclater = true
	actor.player.health = 1
	actor.player.pflags = $ & ~PF_JUMPED
	actor.player.pflags = $ & ~PF_SPINNING
	actor.rchair.tics = 1
	P_KillMobj(actor)
end

function A_Fucked(actor)
	local p = actor.target.player
	MP_giveEffect(p, ef_rocketchair)
	for cock in players.iterate
		COM_BufInsertText(cock, "cecho "..p.name.." \\has failed their mission.")
	end
end

local function efct_rcktchair(mo, inflictor, time)
	local p = mo.player
	local rchair = mo.rchair
	
	if (mo.MP_rocketchair_hit)
		mo.MP_rocketchair_angle = ANG1*P_RandomRange(1, 360)
		MP_loseEffect(p, ef_rocketchair)
		P_RemoveMobj(rchair)
		return
	end
	
	p.drawangle = mo.angle
	mo.state = S_PLAY_PAIN
	mo.momx, mo.momy, mo.momz = 0, 0, 0
	
	if not mo.rchair or not mo.rchair.valid
		MP_loseEffect(p, ef_rocketchair)
		mo.rchair = nil
		return
	end
		
	
	P_TeleportMove(mo, rchair.x, rchair.y, rchair.z + rchair.height)
	if (time < TICRATE*4)	-- starting to launch
		P_InstaThrust(rchair, mo.angle, mo.scale)

		for i =1,3
			local truc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_SMOKE)
			truc.scale = FRACUNIT
			truc.destscale = 1
			truc.momx = P_RandomRange(-3, 3)*FRACUNIT
			truc.momy = P_RandomRange(-3, 3)*FRACUNIT
			truc.momz = P_RandomRange(-2, -5)*FRACUNIT
		end		
	else	-- launching, thrust forward!
		if (time == TICRATE*4)	-- starting boost
			S_StartSound(mo.rchair, sfx_belnch)
			S_StartSound(mo.rchair, sfx_beeyow)
			S_StartSound(mo, sfx_nani)
		end

		for i =1,10
			local cucc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_BOSSEXPLODE)
			cucc.scale = FRACUNIT*2
			cucc.destscale = 1
			cucc.momx = P_RandomRange(-3, 3)*FRACUNIT
			cucc.momy = P_RandomRange(-3, 3)*FRACUNIT
			cucc.momz = P_RandomRange(-2, -5)*FRACUNIT
		end

		for i =1,10
			local truc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_SMOKE)
			truc.scale = FRACUNIT*2
			truc.destscale = 1
			truc.momx = P_RandomRange(-3, 3)*FRACUNIT
			truc.momy = P_RandomRange(-3, 3)*FRACUNIT
			truc.momz = P_RandomRange(-2, -5)*FRACUNIT
		end
		
		P_Thrust(rchair, mo.angle, mo.scale*8)
	end
	/*
	if mo.health
		if time < TICRATE*4
			P_SetObjectMomZ(mo.rchair, FRACUNIT/4)

			for i =1,3
				local cucc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_BOSSEXPLODE)
				cucc.scale = FRACUNIT
				cucc.destscale = 1
				cucc.momx = P_RandomRange(-3, 3)*FRACUNIT
				cucc.momy = P_RandomRange(-3, 3)*FRACUNIT
				cucc.momz = P_RandomRange(-2, -5)*FRACUNIT
			end

			for i =1,3
				local truc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_SMOKE)
				truc.scale = FRACUNIT
				truc.destscale = 1
				truc.momx = P_RandomRange(-3, 3)*FRACUNIT
				truc.momy = P_RandomRange(-3, 3)*FRACUNIT
				truc.momz = P_RandomRange(-2, -5)*FRACUNIT
			end
		else
			if time == TICRATE*4
				S_StartSound(mo.rchair, sfx_belnch)
				S_StartSound(mo.rchair, sfx_beeyow)
				S_StartSound(mo, sfx_nani)
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.floorz, MT_SMOKE)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.destscale = FRACUNIT*10
					P_InstaThrust(dust, dust.angle, 20*FRACUNIT)
				end
			end

			for i =1,10
				local fucc = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_BOSSEXPLODE)
				fucc.scale = FRACUNIT*2
				fucc.destscale = 1
				fucc.momx = P_RandomRange(-5, 5)*FRACUNIT
				fucc.momy = P_RandomRange(-5, 5)*FRACUNIT
				fucc.momz = P_RandomRange(0, -10)*FRACUNIT
			end

			for	i =1,10
				local succ = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*FRACUNIT, mo.y+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, -20)*FRACUNIT, MT_SMOKE)
				succ.scale = FRACUNIT*2
				succ.destscale = 1
				succ.momx = P_RandomRange(-5, 5)*FRACUNIT
				succ.momy = P_RandomRange(-5, 5)*FRACUNIT
				succ.momz = P_RandomRange(-4, -10)*FRACUNIT
			end

			for rover in mo.subsector.sector.ffloors()
				if rover.flags & FF_EXISTS
				and rover.flags & FF_SOLID
				and mo.rchair.z+mo.rchair.height >= rover.bottomheight-FRACUNIT*2
				and mo.rchair.z <= rover.topheight+FRACUNIT*2
					MP_chairKill(mo)
				end
			end

			P_SetObjectMomZ(mo.rchair, FRACUNIT*60)
			if mo.rchair.z+mo.rchair.height >= mo.ceilingz
			and not (mo.eflags & MFE_VERTICALFLIP)
				MP_chairKill(mo)
			end

			if mo.z <= mo.floorz
			and mo.eflags & MFE_VERTICALFLIP
				MP_chairKill(mo)
			end

			if mo.eflags & MFE_VERTICALFLIP
				MP_chairKill(mo)
			end
		end
		P_TeleportMove(mo, mo.rchair.x, mo.rchair.y, mo.rchair.z)
		mo.state = S_PLAY_PAIN
	end*/
end

local function rocketchair_damage(ref, found)
	if not ((found and found.valid) or found.health) then return end
	if (ref == found) then return end

	if not ((found.flags & (MF_SHOOTABLE|MF_ENEMY)) or found.player) then return end
	if (found.flags & MF_MONITOR) then return end
	if not (P_CheckSight(ref, found)) then return end

	-- launch
	if not (abs(ref.z - found.z) <= 256*ref.scale) then return end	-- z check
	
	if (P_DamageMobj(found, ref, ref))
	and ((found and found.valid) and found.health)	-- only if we're still alive
		local angle = R_PointToAngle2(found.x, found.y, ref.x, ref.y)
		
		if (found.player) 
			found.player.drawangle = angle 
		else
			found.angle = angle
		end
		P_InstaThrust(found, angle, -(20*found.scale))
		P_SetObjectMomZ(found, 20*FRACUNIT)
	end
end

local rcktchair_data = {
	func = efct_rcktchair,
	get = function(mo)
		local p = mo.player
				
		-- change music & start sounds
		S_ChangeMusic("BEATS", false, p)
		S_StartSound(nil, sfx_blst1, p)
		S_StartSound(mo, sfx_bejet1)
				
		-- spawn chair
		local rchair = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_MP_ROCKETCHAIR)
		rchair.target = mo
		rchair.scale = FRACUNIT*2
		mo.rchair = rchair
				
		-- set player state
		p.drawangle = mo.angle
		p.pflags = $ & ~(PF_STARTJUMP|PF_JUMPED|PF_SPINNING)
		mo.state = S_PLAY_PAIN
		mo.momx, mo.momy, mo.momz = 0, 0, 0
		P_TeleportMove(mo, rchair.x, rchair.y, rchair.z + rchair.height)
	end,
	hit = function(mo)	-- technically a pseudo "lose" function
		local p = mo.player
		if not (mo.MP_effects[ef_rocketchair]) then return end
		if (mo.MP_rocketchair_launch) then return end	-- separate function
		
		-- blow up when you get hit!
		mo.MP_rocketchair_hit = true
	end,
	lose = function(mo)	-- blow up!
		local p = mo.player
		
		-- damage player
		mo.MP_rocketchair_launch = true	-- prevent the hit function from running!
		if not (mo.MP_rocketchair_hit) then P_DamageMobj(mo, nil, nil) end
		
		-- launch player
		if ((mo and mo.valid) and mo.health)	-- only if we're still alive
			p.drawangle = mo.MP_rocketchair_angle or 0
			P_InstaThrust(mo, mo.MP_rocketchair_angle or 0, -(20*mo.scale))
			P_SetObjectMomZ(mo, 20*FRACUNIT)
			P_RestoreMusic(p)
		end
		
		-- damage nearby objects
		local dist = FixedMul(mo.scale, 256*FRACUNIT)
		searchBlockmap("objects", rocketchair_damage, mo, mo.x - dist, mo.x + dist, mo.y - dist, mo.y + dist)
		S_StartSound(mo, sfx_meboom)
		
		-- remove player vars
		mo.MP_rocketchair_angle, mo.MP_rocketchair_launch = nil, nil
		mo.MP_rocketchair_hit = nil
	end,
	hudfunc = function(v, p, c, t)
		local x, y = -50 + t*2/3, -50+t*3/4
		local transparency = min(V_90TRANS, V_10TRANS * (t/10))
		if t < TICRATE*4
			v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT*8/6, v.cachePatch("CHAIROL"), V_SNAPTOLEFT|transparency)
		end
	end
}
effectList[ef_rocketchair] = rcktchair_data

-- blow up when we've got blocked movement
addHook("MobjMoveBlocked", function(rchair)
	local p = rchair.target.player
	if not (p.mo.MP_effects[ef_rocketchair]) then return end
	
	local timer = p.mo.MP_effects[ef_rocketchair]
	if (timer >= 4*TICRATE)	-- boom
		p.mo.MP_rocketchair_angle = R_PointToAngle2(0, 0, rchair.momx, rchair.momy)
		MP_loseEffect(p, ef_rocketchair)
		P_RemoveMobj(rchair)
	end
end, MT_MP_ROCKETCHAIR)

MP_buildMonitor(MT_INSTAMONITOR, MT_INSTAICON, S_INSTATV, S_INSTAPOP1, SPR_INMT, SPR_INMT, A_Fucked)