-- true batkanese

for i = 1, 3
	freeslot("sfx_tbat"..i)
end

local function bkanLightning(mo, arg)	-- Snu, my beloved, it's in times like these you should use functions;
	S_StartSound(nil, _G["sfx_litng"..P_RandomRange(1, 4)])
	for i = 1, 16

		local target = P_SpawnMobj(mo.x + P_RandomRange(-1536, 1536)*mo.scale, mo.y + P_RandomRange(-1536, 1536)*mo.scale, mo.floorz, MT_THOK)
		target.state = S_INVISIBLE
		target.tics = 2
		MP_spawnLightning(target, arg and SKINCOLOR_PURPLE or SKINCOLOR_PINK, arg and SKINCOLOR_PINK or SKINCOLOR_PURPLE)
	end
	P_StartQuake(3*FRACUNIT, 100)
	MP_spawnLightning(mo, arg and SKINCOLOR_PURPLE or SKINCOLOR_PINK, arg and SKINCOLOR_PINK or SKINCOLOR_PURPLE)
end

local function MP_BKanLaserThinker(mo)
	local x, y, z = mo.x, mo.y, mo.z

	if mo.momx ~= 0 or mo.momy ~= 0
		if not P_TryMove(mo, mo.x + mo.momx*3/2, mo.y + mo.momy*3/2, true) return true end
		if not mo.valid return true end
	end

	if mo.momz ~= 0
		mo.z = $ + mo.momz*3/2
		if mo.z < mo.floorz or mo.z + mo.height > mo.ceilingz return true end
	end

	return not mo.valid or x == mo.x and y == mo.y and z == mo.z
end

local function MP_BKanLaser(mo, long)
	local nblockmap = not (mo.flags & MF_NOBLOCKMAP)

	for i = 0, 256
		if nblockmap
			mo.flags = $ | MF_NOBLOCKMAP
		end

		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale*3/2
		p.destscale = 1
		p.scalespeed = mo.scale*3/2/12
		p.sprite = SPR_NTHK
		p.frame = A|FF_FULLBRIGHT
		p.color = i%2 and SKINCOLOR_PURPLE or SKINCOLOR_PINK
		p.tics = TICRATE

		p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale*3/2*3/2
		p.destscale = 1
		p.sprite = SPR_NTHK
		p.frame = A|TR_TRANS80|FF_FULLBRIGHT
		p.scalespeed = mo.scale*3/2/12
		p.color = SKINCOLOR_WHITE
		p.tics = TICRATE

		if MP_BKanLaserThinker(mo)
			break
		end
	end
	mo.scale = $*4
	A_MPRingExplode(mo)
	P_ExplodeMissile(mo)
end

local HU_bootqueue	= {		-- pre defined boot messages for the batkan transformation
	"GAME LOGIC OVERRIDE START",
	"Accessing MonitorsPlus libs...",
	"Caching all sectors brightness...",
	"Darkening all sectors for dramatic effect...",
	"Removing effects to avoid conflicts...",
	"Removing weapons to avoid conflicts...",
	"Overwriting effect value to ef_truebatkanese...",
	"Setting health field to maintain Super...",
	"Override Super transformation...",
	"Override Player character stats...",
	"Override Player flags...",
	"GAME LOGIC OVERRIDE COMPLETE",
	"GENERATING CODE TO OVERRIDE GAME LOGIC WITH...",

	"function(mo)",
	"	local p = mo.player",
	"	local bcolour = batkancolours[(leveltime or 1)/2%(#batkancolours)+1]",
	"	mo.player.pflags = $1|PF_GODMODE",
	"	local kanspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(-30, 30)*mo.scale, mo.z)",
	"	if kanspark",
	"		P_SetObjectMomZ(kanspark, 10*kanspark.scale)",
	"		kanspark.scalespeed = FRACUNIT/18",
	"		kanspark.destscale = 1",
	"		kanspark.fuse = 30",
	"		kanspark.color = bcolour",
	"	end",
	"	mo.color = bcolour",
	"	mo.frame = $|FF_FULLBRIGHT",
	"	mo.MP_weapondelay = TICRATE",

	"	if not (leveltime%TICRATE*4)",
	"		bkanLightning(mo, not (leveltime%TICRATE*8))",
	"	end",

	"	if mo.state < S_PLAY_SUPER_TRANS1 or mo.state > S_PLAY_SUPER_TRANS6",
	"		if not P_IsObjectOnGround(mo)",
	"			p.acceleration = 90",
	"			p.thrustfactor = 5",
	"			p.accelstart = 255",
	"		else",
	"			p.acceleration = skins[mo.skin].acceleration",
	"			p.thrustfactor = skins[mo.skin].thrustfactor",
	"			p.accelstart = skins[mo.skin].accelstart",
	"		end",

	"		p.pflags = $|PF_THOKKED",
	"		p.pflags = $ & ~PF_JUMPED",
	"		p.jumpfactor = 0",
	"		local cmd = mo.player.cmd.buttons",
	"		if cmd & BT_JUMP",
	"			P_SetObjectMomZ(mo, mo.scale, true)",
	"		elseif cmd & BT_USE",
	"			P_SetObjectMomZ(mo, -mo.scale, true)",
	"		else",
	"			P_SetObjectMomZ(mo, -mo.momz/8, true)",
	"		end",

	"		if cmd & BT_ATTACK",
	"			mo.bkanlaser = $+1",
	"		else",
	"			mo.bkanlaser = 0",
	"		end",

	"		if mo.bkanlasercd",
	"			mo.bkanlasercd = $-1",
	"		end",

	"		if mo.bkanlaser == 1",
	"		and not mo.bkanlasercd",
	"			local msl = P_SpawnPlayerMissile(mo, MT_JDRIVELASER, MF2_EXPLOSION)",
	"			if not msl return end",
	"			MP_BKanLaser(msl, true)",
	"			mo.bkanlasercd = TICRATE/2",
	"		end",
	"	end",
	"end",
	"OVERRIDE COMPLETE!"
}

local HU_consolequeue = 0	-- used for nice programming like things
local HU_scroll = 0

local function Batkanese(mo)

	HU_consolequeue = 0
	HU_scroll = 0

	for s in sectors.iterate do
		if s and s.valid
			s.lightlevel = $*9/10
		end
	end

	local player = mo.player
	local p = player

	MP_TurnSuper(p)
	S_StopSound(player.mo)
	S_StartSound(nil, sfx_s3k9f)
	for p in players.iterate do
		P_PlayJingleMusic(p, "TBTKAN")
	end	
	
	P_PlayJingleMusic(mo.player, "TBTKAN", 0, true, JT_SUPER)
	
	for i = 0, 99
		if i ~= ef_truebatkanese
		and mo.MP_effects[i]
			MP_loseEffect(p, i)
		end
	end
	mo.MP_weapons = 0
	mo.tbatkantimer = 0
	mo.tbatkanmomz = 0
	p.charability = 0
	p.charability2 = 0
	p.jumpfactor = 0
	mo.flags = $|MF_NOGRAVITY
	mo.tbatkanenergy = 50000
	mo.bkanbuster = nil

	if mo.player == consoleplayer
		hud.disable("weaponrings")
	end

	if G_RingSlingerGametype()
		COM_BufInsertText(server, "csay "..player.name.." \\has gone \\TRUE BATKANAESE!")
	end
	P_StartQuake(FRACUNIT*40, 35)
	for p in players.iterate do
		P_FlashPal(p, 1, 20)
	end
	
	S_StartSound(nil, sfx_tbat1)

end

local hex = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, "A", "B", "C", "D", "E", "F"}

local batkancolours = {SKINCOLOR_PURPLE, SKINCOLOR_LAVENDER, SKINCOLOR_PINK, SKINCOLOR_WHITE, SKINCOLOR_PINK, SKINCOLOR_LAVENDER}
local batkan_data = {
	time = 100*TICRATE,
	func = function(mo)
				local p = mo.player
				local bcolour = batkancolours[(leveltime or 1)/2%(#batkancolours)+1]	-- fuck your ifs and elseifs
				mo.player.pflags = $1|PF_GODMODE
				p.rings = 9999
				local kanspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(-30, 30)*mo.scale, mo.z)
				if kanspark
					P_SetObjectMomZ(kanspark, 10*kanspark.scale)
					kanspark.scale = FRACUNIT/2
					kanspark.scalespeed = FRACUNIT/18
					kanspark.destscale = 1
					kanspark.scale = mo.scale/2
					kanspark.fuse = 30
					kanspark.color = bcolour
				end
				mo.color = bcolour
				mo.frame = $|FF_FULLBRIGHT
				mo.MP_weapondelay = TICRATE

				if p.cmd.buttons & BT_FIRENORMAL
				and mo.bkanbuster == 1
					mo.bkanbuster = 2
				end
				if mo.bkanbuster and mo.bkanbuster >= 2
					mo.MP_effects[ef_truebatkanese] = TICRATE*69

					if mo.bkanbuster < TICRATE*3
						if mo.bkanbuster == 3
							S_StartSound(nil, sfx_rumble)
							S_StartSound(nil, sfx_tbat2)
						end
						P_StartQuake(FRACUNIT*70, 90)
						
						if G_RingSlingerGametype()
							COM_BufInsertText(server, "csay "..p.name.." \\has initiated the \\HYPER BATKAN BUSTER!!!")
						end
						mo.state = S_PLAY_SUPER_TRANS1
					elseif mo.bkanbuster < TICRATE*10
						for player in players.iterate do
							if player.mo and player.mo.valid
								if mo.bkanbuster == TICRATE*6
									HU_explosion(player)
									S_StartSound(nil, sfx_meboom)
								end
								for i = 1, 8
									local t = P_SpawnMobj(player.mo.x + P_RandomRange(-32, 32)*mo.scale, player.mo.y + P_RandomRange(-32, 32)*mo.scale, player.mo.z, MT_THOK)
									t.scale = mo.scale/2
									t.color = SKINCOLOR_PURPLE
									t.momz = 8<<FRACBITS
									t.destscale = 1
								end
							end
						end
						
						if mo.bkanbuster == TICRATE*7
							S_StartSound(nil, sfx_tbat3)
						end
						
					elseif mo.bkanbuster == TICRATE*10
						for player in players.iterate
							player.score = 0
						end
						p.score = 69696969
						G_ExitLevel()
					end
					mo.bkanbuster =$+1
					return
				end

				if not (leveltime%TICRATE*4)
					bkanLightning(mo, not (leveltime%TICRATE*8))
				end
				-- handle controls
				if mo.state < S_PLAY_SUPER_TRANS1 or mo.state > S_PLAY_SUPER_TRANS6

					-- acceleration handler
					if not P_IsObjectOnGround(mo)
						p.acceleration = 90
						p.thrustfactor = 5
						p.accelstart = 255
					else
						p.acceleration = skins[mo.skin].acceleration
						p.thrustfactor = skins[mo.skin].thrustfactor
						p.accelstart = skins[mo.skin].accelstart
					end

					-- momz stuff
					p.pflags = $|PF_THOKKED
					p.pflags = $ & ~PF_JUMPED
					p.jumpfactor = 0
					local cmd = mo.player.cmd.buttons
					if cmd & BT_JUMP
						P_SetObjectMomZ(mo, mo.scale, true)
					elseif cmd & BT_USE
						P_SetObjectMomZ(mo, -mo.scale, true)
					else
						P_SetObjectMomZ(mo, -mo.momz/8, true)
					end

					-- big lazor
					if cmd & BT_ATTACK
						mo.bkanlaser = $+1
					else
						mo.bkanlaser = 0
					end

					if mo.bkanlasercd
						mo.bkanlasercd = $-1
					end

					if mo.tbatkanenergy >= 100000 - 2000 and not mo.bkanbuster
						mo.bkanbuster = 1
					end

					mo.tbatkanenergy = max(0, $-30)

					if mo.tbatkanenergy <= 0
						MP_loseEffect(p, ef_truebatkanese)
					end

					if mo.bkanlaser == 1	-- firing
					and not mo.bkanlasercd
						local msl = P_SpawnPlayerMissile(mo, MT_JDRIVELASER, MF2_EXPLOSION)
						if not msl return end
						MP_BKanLaser(msl, true)
						mo.bkanlasercd = TICRATE/2
						mo.tbatkanenergy = $-1000
					end

				end
			end,
	get = function(mo)
			Batkanese(mo)
			P_SetupLevelSky(760)
		end,
	lose = function(mo)
	
				if mo.player == consoleplayer
					hud.enable("weaponrings")
				end
	
				local p = mo.player
				P_GivePlayerRings(p, -9999)
				mo.player.pflags = $1 & ~PF_GODMODE
				mo.flags = $ & ~MF_NOGRAVITY
				resetStats(mo)
				P_RestoreMusic(mo.player)

				for s in sectors.iterate do
					if s and s.valid
						s.lightlevel = server.MP_savesectors[#s].lightlevel
					end
				end
				P_SetupLevelSky(mapheaderinfo[gamemap].skynum, nil)
				
				COM_BufInsertText(server, "csay "..p.name.."\\has lost their divine powers...")
			end,

	hudfunc = 	function(v, p, c, t)

						-- energy bar or smthin
						v.drawFill(40, 180, 240, 8, 238|V_SNAPTOBOTTOM)
						v.drawFill(41, 181, p.mo.tbatkanenergy*238/100000, 6, (192 + leveltime%8)|V_SNAPTOBOTTOM)
						v.drawString(42, 175, "\x81".."ENERGY:", V_SNAPTOBOTTOM)

						if p.mo.bkanbuster == 1
							v.drawString(160, 160, (leveltime%4 < 2 and "\x81" or "\x80").."HYPER BATKAN BUSTER READY: FIRE NORMAL", V_SNAPTOBOTTOM, "center")
						end

						local basex, basey = hudinfo[HUD_RINGSNUM].x-48, hudinfo[HUD_RINGSNUM].y
						v.drawFill(basex, basey, 86, 20, 238|V_SNAPTOTOP|V_SNAPTOLEFT)

						basex, basey = hudinfo[HUD_RINGSNUM].x-44, hudinfo[HUD_RINGSNUM].y+2

						local str, str2 = "", ""
						for i = 1, 8
							str = $..hex[N_RandomRange(1, #hex)]
							str2 = $..hex[N_RandomRange(1, #hex)]
						end
						v.drawString(basex, basey, "0x"..str.."\n0x"..str2, V_ALLOWLOWERCASE|V_RETURN8|V_SNAPTOTOP|V_SNAPTOLEFT)

						basex, basey = hudinfo[HUD_TICS].x-72, hudinfo[HUD_TICS].y

						v.drawFill(basex, basey, 128, 16, 238|V_SNAPTOTOP|V_SNAPTOLEFT)

						basex, basey = hudinfo[HUD_TICS].x-68, hudinfo[HUD_TICS].y+2

						str, str2 = "", ""
						for i = 1, 12
							str = $..hex[N_RandomRange(1, #hex)]
							str2 = $..hex[N_RandomRange(1, #hex)]
						end
						v.drawString(basex, basey, "0x"..str.."\n0x"..str2, V_ALLOWLOWERCASE|V_RETURN8|V_SNAPTOTOP|V_SNAPTOLEFT)

						basex, basey = hudinfo[HUD_SCORENUM].x-64, hudinfo[HUD_SCORENUM].y

						v.drawFill(basex, basey, 86, 16, 238|V_SNAPTOTOP|V_SNAPTOLEFT)

						basex, basey = hudinfo[HUD_SCORENUM].x-60, hudinfo[HUD_SCORENUM].y+2

						str, str2 = "", ""
						for i = 1, 8
							str = $..hex[N_RandomRange(1, #hex)]
							str2 = $..hex[N_RandomRange(1, #hex)]
						end
						v.drawString(basex, basey, "0x"..str.."\n0x"..str2, V_ALLOWLOWERCASE|V_RETURN8|V_SNAPTOTOP|V_SNAPTOLEFT)

						-- draw the fake code, because we love fake code...
						for i = 1, #HU_bootqueue
							if t > 20 + ((i-1)/2)
								-- check some stuff in the string for indents...
								v.drawString(32, 148+(i-1)*8 -((t-20)*8), HU_bootqueue[i]:gsub("	", "    "), V_ALLOWLOWERCASE|V_PURPLEMAP|V_50TRANS|V_SNAPTOLEFT)
							end
						end

						local flag = max(0, (V_10TRANS * (t/4)))
						if flag <= V_90TRANS
							drawScreenwidePatch(v, v.cachePatch("BKAN"), flag)
						end

				end,

	hudico = "TRUKAICO",
}
effectList[ef_truebatkanese] = batkan_data

addHook("ShouldJingleContinue", function(p, musname)
	if musname == "TBTKAN"
		for p2 in players.iterate do
			if p2 and p2.mo and p2.mo.valid and p2.mo.MP_effects[ef_truebatkanese] return true end
		end
		
		-- also work for normal batkan
		if p and p.mo and p.mo.valid and p.mo.MP_effects[ef_batkan] return true end
	end
end)

addHook("HurtMsg", function(p, inflictor, source)
	if p and p.mo and p.mo.valid and inflictor and inflictor.type == MT_JDRIVELASER
		if MP_isDead(p.mo)
			print(inflictor.target.player.cname.." killed "..p.cname.." with a deadly laser.")
			if inflictor.target.MP_effects[ef_truebatkanese]
				inflictor.target.tbatkanenergy = min(100000, $+20000)
			end
			return true
		else
			print(inflictor.target.player.cname.." hit "..p.cname.." with a deadly laser.")
			if inflictor.target.MP_effects[ef_truebatkanese]
				inflictor.target.tbatkanenergy = min(100000, $+14000)
			end
			return true
		end
	end
end)

hud.add(function(v, p, c)
	local tb
	for p in players.iterate do
		if p and p.mo and p.mo.valid
			if p.mo.bkanbuster and p.mo.bkanbuster > 2
				tb = p.mo.bkanbuster
			end
		end
	end

	if not tb return end
	if tb > TICRATE*7
		v.drawFill(0, 0, 320, 200, 0|V_SNAPTOTOP|V_SNAPTOLEFT)
		local t = tb-(TICRATE*7)
		local flag = max(0, (V_10TRANS * (t/4)))
		if flag <= V_90TRANS
			drawScreenwidePatch(v, v.cachePatch("BKAN"), flag)
		end
	end

end)