local expand_dta = {

	timer = TICRATE*15,

	icon = "EXPANICO",

	stop = function()
				if P_RandomRange(0, 4) == 4 then S_StartSound(nil, sfx_pcake) end
				P_StartQuake(10*FRACUNIT, 314)
				S_StartSound(nil, sfx_rumble)

				for sector in sectors.iterate
					sector.floorheight = $1 / 2
					sector.ceilingheight = $1 / 2
				end

				for side in sides.iterate
					side.rowoffset = $1 / 2
				end

				for mobj in mobjs.iterate()
					if mobj and mobj.valid
						mobj.z = $/2
					end
				end
			end,

	dontdo = function()
				if MP_geffect_active(gef_pancake) or MP_geffect_active(gef_crumble)
					S_StartSound(nil, sfx_lose)
					return true
				end
			end,

	start = function()

				if P_RandomRange(0, 4) == 4 then S_StartSound(nil, sfx_dong) end
				P_StartQuake(10*FRACUNIT, 314)
				S_StartSound(nil, sfx_rumble)

				for sector in sectors.iterate
					sector.floorheight = $1 * 2
					sector.ceilingheight = $1 * 2
				end

				for side in sides.iterate
					side.rowoffset = $1 * 2
				end

				for mobj in mobjs.iterate()
					if mobj and mobj.valid
						mobj.z = $*2
					end
				end

			end,
}
geffectList[gef_expand] = expand_dta


function A_Expand(actor, var1)
	MP_addGlobalEffect(gef_expand)
end

MP_buildMonitor(MT_EXPANDMONITOR, MT_EXPANDICON, S_EXPANDTV, S_EXPANDPOP1, SPR_EXMT, SPR_EXMT, A_Expand)