-- fitness global effect
-- seriously, y'all scripting with thousand of thinkframes is a fucking CATASTROPHE.

local fitngdta = {
	timer = TICRATE*11,
	start =	function()
				P_SetupLevelSky(667, nil)
				S_StartSound(nil, sfx_fitage, player)
				S_ChangeMusic("FITNES", false)
				
				for p in players.iterate
					local mo = p.mo
					if not (mo and mo.valid) then continue end
					
					mo.spawnfitness = true
				end
			end,

	func = 	function(t)
				if TICRATE*10 - t < TICRATE*2
					for p in players.iterate do
						if not (p.mo and p.mo.valid) then continue end
						if not (p.mo.spawnfitness) then continue end
						
						local fit = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.ceilingz-4*FRACUNIT, MT_MASON)
						fit.target = p.mo
						fit.scale = FRACUNIT*3/4
						fit.fuse = TICRATE*21
					end
				end
			end,
	stop = 	function()
				P_SetupLevelSky(mapheaderinfo[gamemap].skynum, nil)
			end
}

geffectList[gef_fitnessgeddon] = fitngdta

addHook("MobjThinker", function(mo)

	if not (mo.target and mo.target.valid and mo.target.player.pizzahit == nil) or (mo.target.player and mo.target.player.exiting) or mo.target.player.spectator then
		if not mo.fitnessstate then
			P_RemoveMobj(mo)
			return

		elseif mo.fitnessstate ~= 2 then
			mo.fitnessstate = 2
		end
	end

	if mo.fitnessstate ~= 2 then
		mo.angle = ANG20*leveltime
	end

	if not mo.fitnessstate then
		mo.flags2 = $1|MF2_DONTDRAW
		if P_AproxDistance(mo.momx, mo.momy) < 40*FRACUNIT then
			P_Thrust(mo, mo.angle, 40*FRACUNIT)
		end

		if P_AproxDistance(mo.x - mo.target.x, mo.y - mo.target.y) > 1024*FRACUNIT then
			mo.fitnessstate = 1
		end

	elseif mo.fitnessstate == 1 then
		mo.flags2 = $1&~(MF2_DONTDRAW)
		mo.momx = $1+(mo.target.x - mo.x)/200
		mo.momy = $1+(mo.target.y - mo.y)/200
		mo.momz = $1+(mo.target.z - mo.z + (20*FRACUNIT))/200
	else
		if mo.fitnesstimer then
			mo.fitnesstimer = $1+1
		else
			mo.fitnesstimer = 1
		end
		if mo.fitnesstimer > 20*TICRATE then
			P_RemoveMobj(mo)
			return
		end

		mo.momz = $1-gravity
	end
end, MT_MASON)

addHook("MobjMoveCollide", function(fitness, mo)

	if mo.player and mo.player.pflags & PF_GODMODE return end

	if not (fitness.fitnessstate == 1 and mo.type == MT_PLAYER and mo.health
			and mo.z <= fitness.z+FixedMul(fitness.height, fitness.scale) and mo.z+FixedMul(mo.height, mo.scale) >= fitness.z) then return end
	
	print(mo.player.cname .. "'s fitness is Mason's buisness.")
	if mo ~= fitness.target and mo.target and mo.target.valid then P_AddPlayerScore(mo.target.player, 100) end
	S_StartSound(nil, _G["sfx_mason"..P_RandomRange(1, 4)])
	P_KillMobj(mo)
	fitness.target = nil
end, MT_MASON)