local hgrvty_dta = {
	timer = TICRATE*15,
	icon = "HEVGRICO",
	start = function()
				S_StartSound(nil, sfx_s3k74)
			end,
	stop = 	function()
				S_StartSound(nil, sfx_s3kd5s)
			end,
	func = 	function()
	
				if MP_geffect_active(gef_lowgrav) return end
	
				for p in players.iterate do
					if p.mo and p.mo.valid and not P_IsObjectOnGround(p.mo)
						P_SetObjectMomZ(p.mo, -gravity, true)
					end
				end
			end,
}
geffectList[gef_heavygrav] = hgrvty_dta

function A_HeavyGravity()
	MP_addGlobalEffect(gef_heavygrav)
end

MP_buildMonitor(MT_HEAVYGRAVMONITOR, MT_HEAVYGRAVICON, S_HEAVYGRAVTV, S_HEAVYGRAVPOP1, SPR_HVGR, SPR_HVGR, A_HeavyGravity)