local lgrvty_dta = {
	timer = TICRATE*15,
	icon = "LOWGRICO",
	start = function()
				S_StartSound(nil, sfx_s3k74)
			end,
	stop = 	function()
				S_StartSound(nil, sfx_s3kd5s)
			end,
	func = 	function()
	
				if MP_geffect_active(gef_heavygrav) return end
	
				for p in players.iterate do
					if p.mo and p.mo.valid and not P_IsObjectOnGround(p.mo)
						P_SetObjectMomZ(p.mo, (gravity/2), true)
					end
				end
			end,
}
geffectList[gef_lowgrav] = lgrvty_dta

function A_LowGravity()
	MP_addGlobalEffect(gef_lowgrav)
end

MP_buildMonitor(MT_LOWGRAVMONITOR, MT_LOWGRAVICON, S_LOWGRAVTV, S_LOWGRAVPOP1, SPR_LOGR, SPR_LOGR, A_LowGravity)