	--===MonitorsPlus Freeslots==--

-- VVV DBG INFO VVV
rawset(_G, "MP_monitorsConstants", {})
rawset(_G, "MP_shieldConstants", {})
rawset(_G, "MP_effectConstants", {})
rawset(_G, "MP_geffectConstants", {})

-- weapons stuff:
freeslot("SPR_ATTV", "SPR_BNTV", "SPR_BMTV", "SPR_GETV", "SPR_IFTV", "SPR_RLTV", "SPR_SCTV")

local function freeslotTV(name, sname)

	MP_monitorsConstants[#MP_monitorsConstants+1] = "MT_"..name.."MONITOR"	-- used for dbg admin menu

	freeslot(
"MT_"..name.."MONITOR",
"MT_"..name.."ICON",
"S_"..sname.."TV",
"S_"..sname.."TV1",
"S_"..sname.."TV2",
"S_"..sname.."POP1",
"S_"..sname.."POP2",
"S_"..sname.."POP3",
"S_"..sname.."POP4",
"S_"..sname.."POP5")
end

-- auto ring tv:
freeslotTV("AUTOMATIC", "AUTO")

-- bounce:
freeslotTV("BOUNCE", "BOUNCE")

-- bomb:
freeslotTV("BOMB", "BOMB")

-- grenade:
freeslotTV("GRENADE", "GRENADE")

-- infinite:
freeslotTV("INFINITY", "INFINITY")

-- rail:
freeslotTV("RAIL", "RAIL")

-- scatter:
freeslotTV("SCATTER", "SCAT")	-- < ew

--Misc Sounds--
freeslot(
"sfx_nukes",
"sfx_elem",
"sfx_bucket",
"sfx_desnd1",
"sfx_desnd2",
"sfx_desnd3"
)

--Super Monitor--
freeslotTV("SUPER", "SUPER")
freeslot(
"S_SUBX",
"S_SUBX1",
"S_SUBX2",
"SPR_SUBX",
"SPR_SUSP",
"S_SUPERPART1",
"S_SUPERPART2",
"S_SUPERPART3",
"S_SUPERPART4",
"S_SUPERPART5",
"S_SUPERPART6",
"S_SUPERPART7",
"S_SUPERPART8",
"S_SUPERPART9",
"MT_SUPERPARTICLE"
)

--Hyper Monitor--
freeslotTV("HYPER", "HYPER")
freeslot(
"S_HYPERPART1",
"S_HYPERPART2",
"S_HYPERPART3",
"S_HYPERPART4",
"S_HYPERPART5",
"S_HYPERPART6",
"S_HYPERPART7",
"S_HYPERPART8",
"MT_HYPERPARTICLE",
"SPR_SUBP",
"MT_HYPERBIRD",
"S_HYPERBIRD1",
"S_HYPERBIRD2",
"S_PLAY_HYPERTRANS3",
"S_PLAY_HYPERTRANS4",
"S_PLAY_HYPERTRANS5",
"S_PLAY_HYPERTRANS6",
"S_PLAY_HYPERTRANS7",
"S_PLAY_HYPERTRANS8",
"S_PLAY_HYPERTRANS9",
"SPR_HYMT",
"SPR_HBIR",
"S_BIRD1",
"S_BIRD2"
)

--Instakill Monitor--
freeslotTV("INSTA", "INSTA")
freeslot(
"SPR_INMT",
"sfx_haaaa",
"sfx_haaa2",
"SPR_CHAI",
"sfx_nani"
)

--Cactis Shield--
freeslotTV("CACTISHIELD", "CC")
freeslot(
"SPR_CCTV",
"SPR_CSPK",
"SPR_CCPK",
"MT_CACTISPIKE",
"MT_CACTISHIELDMONITOR",
"MT_CACTISHIELDICO",
"S_CACTISHIELD_FRONT1",
"S_CACTISHIELD_FRONT2",
"S_CACTISHIELD_FRONT3",
"S_CACTISHIELD_FRONT4",
"S_CACTISHIELD_BACK1",
"S_CACTISHIELD_BACK2",
"S_CACTISHIELD_BACK3",
"S_CACTISHIELD_BACK4",
"S_CACTISHIELD_ORB1",
"S_CACTISHIELD_ORB2",
"S_CACTISHIELD_ORB3",
"S_CACTISHIELD_ORB4",
"S_CACTISHIELD_ORB5",
"S_CACTISHIELD_ORB6",
"S_CACTISHIELD_FRONT_B1",
"S_CACTISHIELD_FRONT_B2",
"S_CACTISHIELD_FRONT_B3",
"S_CACTISHIELD_FRONT_B4",
"S_CACTISHIELD_BACK_B1",
"S_CACTISHIELD_BACK_B2",
"S_CACTISHIELD_BACK_B3",
"S_CACTISHIELD_BACK_B4",
"S_CACTISHIELD_ORB_B1",
"S_CACTISHIELD_ORB_B2",
"S_CACTISHIELD_ORB_B3",
"S_CACTISHIELD_ORB_B4",
"S_CACTISHIELD_ORB_B5",
"S_CACTISHIELD_ORB_B6",
"S_CACTISPIKE",
"SPR_PITY"
)

--End of the World Monitor--
freeslotTV("END", "END")
freeslot(
"SPR_ENDD"
)

--Random Hit Monitor--
freeslotTV("RANDOM", "RAND")
freeslot(
"SPR_RAND",
"sfx_ripzet",
"sfx_dollht",
"SPR_RXPL",
"MT_SONXPL",
"S_SONXPL1",
"S_SONXPL2",
"S_SONXPL3",
"S_SONXPL4",
"S_SONXPL5",
"S_SONXPL6",
"S_SONXPL7",
"S_SONXPL8",
"S_SONXPL9",
"S_SONXPL10",
"S_SONXPL11",
"S_SONXPL12",
"S_SONXPL13",
"S_SONXPL14",
"S_SONXPL15",
"S_SONXPL16",
"S_SONXPL17",
"S_SONXPL18",
"S_SONXPL19",
"S_SONXPL20",
"S_SONXPL21",
"sfx_meboom",
"sfx_mchurt"
)

--Kinetic Shield--
freeslotTV("ANTIMATTER", "ANTI")
freeslot(
"SPR_ANTV",
"MT_ANTISHIELD",
"SPR_ANTP",
"MT_ANTIPARTICLE",
"S_ANTIPART1",
"S_ANTIPART2",
"S_ANTIPART3",
"S_ANTIPART4",
"S_ANTIPART5",
"S_ANTIPART6",
"S_ANTIPART7",
"SPR_ANTI",
"S_ANTISHIELD1",
"S_ANTISHIELD2",
"S_ANTISHIELD3",
"S_ANTISHIELD4",
"S_ANTISHIELD5",
"S_ANTISHIELD6",
"S_ANTISHIELD7",
"S_ANTISHIELD8",
"S_ANTISHIELD9",
"S_ANTISHIELD10",
"S_ANTISHIELD11",
"S_ANTISHIELD12",
"S_ANTISHIELD13",
"S_ANTISHIELD14",
"S_ANTISHIELD15",
"S_ANTISHIELD16",
"S_ANTISHIELD17",
"S_ANTISHIELD18",
"S_ANTISHIELD19",
"S_ANTISHIELD20",
"S_ANTISHIELD21",
"S_ANTISHIELD22",
"S_ANTISHIELD23",
"S_ANTISHIELD24",
"S_ANTISHIELD25",
"S_ANTISHIELD26",
"S_ANTISHIELD27",
"S_ANTISHIELD28",
"S_ANTISHIELD29",
"S_ANTISHIELD30",
"S_ANTISHIELD31",
"S_ANTISHIELD32",
"sfx_antis",
"sfx_kineti"
)

--Silver Ring Monitor--
freeslotTV("SILVERRINGBOX", "SRING")
freeslot(
"SPR_SSBX",
"sfx_silv"
)

--Earthquake Monitor--
freeslotTV("EARTH", "EARTH")
freeslot(
"SPR_ERBX",
"sfx_wahomg"
)

--Super Sparks--
freeslot(
"S_SUPERPART1",
"S_SUPERPART2",
"S_SUPERPART3",
"S_SUPERPART4",
"S_SUPERPART5",
"S_SUPERPART6",
"S_SUPERPART7",
"S_SUPERPART8",
"S_SUPERPART9",
"S_SUPERPART10",
"S_SUPERPART11",
"S_SUPERPART12",
"MT_SUPERPARTICLE",
"SPR_SUSP"
)
states[S_SUPERPART1] = {SPR_SUSP, A, 2, A_SparkleThink, 0, 0, S_SUPERPART2}
states[S_SUPERPART2] = {SPR_SUSP, B, 2, A_SparkleThink, 0, 0, S_SUPERPART3}
states[S_SUPERPART3] = {SPR_SUSP, C, 2, A_SparkleThink, 0, 0, S_SUPERPART4}
states[S_SUPERPART4] = {SPR_SUSP, D, 2, A_SparkleThink, 0, 0, S_SUPERPART5}
states[S_SUPERPART5] = {SPR_SUSP, E, 2, A_SparkleThink, 0, 0, S_SUPERPART6}
states[S_SUPERPART6] = {SPR_SUSP, F, 2, A_SparkleThink, 0, 0, S_SUPERPART7}
states[S_SUPERPART7] = {SPR_SUSP, G, 2, A_SparkleThink, 0, 0, S_SUPERPART8}
states[S_SUPERPART8] = {SPR_SUSP, H, 2, A_SparkleThink, 0, 0, S_SUPERPART9}
states[S_SUPERPART9] = {SPR_SUSP, I, 2, A_SparkleThink, 0, 0, S_SUPERPART10}
states[S_SUPERPART10] = {SPR_SUSP, J, 2, A_SparkleThink, 0, 0, S_SUPERPART11}
states[S_SUPERPART11] = {SPR_SUSP, K, 2, A_SparkleThink, 0, 0, S_SUPERPART12}
states[S_SUPERPART12] = {SPR_SUSP, L, 2, A_SparkleThink, 0, 0, S_NULL}
mobjinfo[MT_SUPERPARTICLE] = {
	doomednum = -1,
    spawnstate = S_SUPERPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}

--Drop Monitor--
freeslotTV("LOSE", "LOSE")
freeslot(
"SPR_LOBX"
)

--Lightning Monitor--
freeslotTV("SHRINK", "SHRI")
freeslot(
"SPR_SHMT",
"SPR_EZIO",
"S_ZIO1",
"S_ZIO2",
"S_ZIO3",
"S_ZIO4",
"S_ZIO21",
"S_ZIO22",
"S_ZIO23",
"S_ZIO24",
"sfx_zio3"
)

--Supply Monitor--
freeslotTV("SUPPLY", "SUPP")
freeslot(
"SPR_SUMT"
)

--Mushroom Monitor--
freeslotTV("MUSH", "MUSH")
freeslot(
"SPR_MUMT"
)

--Invisibility Monitor--
freeslotTV("INVIS", "INVIS")
freeslot(
"SPR_INVI"
)

--Poison Shield--
freeslotTV("POISON", "PSN")
freeslot(
"MT_POISONTRAIL",
"MT_POISONPROJ",
"SPR_PSNP",
"S_POISONTRAIL1",
"S_POISONTRAIL2",
"S_POISONTRAIL3",
"S_POISONTRAIL4",
"SPR_PSTV",
"SPR_PSNS",
"S_PSN_ORB1",
"S_PSN_ORB2",
"S_PSN_ORB3",
"S_PSN_ORB4",
"S_PSN_ORB5",
"S_PSN_ORB6",
"S_PSN_ORB7",
"S_PSN_ORB8",
"S_PSN_ORB9",
"S_PSN_ORB10",
"S_PSN_ORB11",
"S_PSN_ORB12",
"sfx_psnr",
"sfx_psn",
"sfx_psned"
)

--ESP Shield--
freeslotTV("ESP", "ESP")
freeslot(
"SPR_ESPT",
"SPR_ESPS",
"MT_ESPHITBOX",
"S_ESP_ORB1",
"S_ESP_ORB2",
"S_ESP_ORB3",
"S_ESP_ORB4",
"S_ESP_ORB5",
"S_ESP_ORB6",
"S_ESP_ORB7",
"S_ESP_ORB8",
"S_ESP_ORB9",
"S_ESP_ORB10",
"S_ESP_ORB11",
"S_ESP_ORB12",
"sfx_reflect"
)

--Jump Height Monitor--
freeslotTV("JUMP", "JUMP")
freeslot(
"SPR_JUTV",
"sfx_cdjump",
"MT_JUMPPARTICLE",
"S_JUMPPART1",
"S_JUMPPART2",
"S_JUMPPART3",
"S_JUMPPART4",
"SPR_JUPT"
)

--Ice Shield--
freeslotTV("ICE", "ICE")
freeslot(
"MT_FREEZEICE",
"S_ICEPOWDER1",
"S_ICEPOWDER2",
"S_ICEPOWDER3",
"S_ICEPOWDER4",
"SPR_ICEP",
"SPR_ICET",
"SPR_ICES",
"S_ICE_ORB1",
"S_ICE_ORB2",
"S_ICE_ORB3",
"S_ICE_ORB4",
"S_ICE_ORB5",
"S_ICE_ORB6",
"S_ICE_ORB7",
"S_ICE_ORB8",
"S_ICE_ORB9",
"S_ICE_ORB10",
"S_ICE_ORB11",
"S_ICE_ORB12",
"sfx_ices1",
"sfx_ices2",
"sfx_ices3",
"sfx_ices4",
"sfx_ices5",
"sfx_glgz5"
)

--Combine Ring/Hyper Ring--
freeslotTV("COMBINERING", "CRING")
rawset(_G, "Unholy ", "kanade")
freeslotTV("HYPERRING", "HRING")
freeslot(
"SFX_HYPRNG",
"SPR_CRBX",
"SPR_CRNG",
"SPR_HRBX",
"SPR_HRNG",
"S_CRNG",
"S_HRNG"
)
for i = 1, 6, 1
	freeslot("S_COMBINERINGBOX"+i)
end

--Hyper Ring Monitor--
rawset(_G,
	"B4TKAN", "serena"
)
for i = 1, 6, 1
	freeslot("S_HYPERRINGBOX"+i)
end

--Reset Score Monitor--
freeslotTV("RESET", "RESET")
freeslot(
"SPR_REST"
)

--Firerate Monitor--
freeslotTV("FIRE", "FIRR")
freeslot(
"SPR_FIRR",
"sfx_firera",
"MT_FIREPARTICLE",
"S_FIREPART1",
"S_FIREPART2",
"S_FIREPART3",
"S_FIREPART4",
"SPR_FIRP"
)

--Mr Bean Monitor--
freeslotTV("BEAN", "BEAN")
freeslot(
"sfx_beanby",
"sfx_beanb1",
"sfx_beanb2",
"sfx_beanb3",
"sfx_beanb4",
"SPR_BEAN"
)

--Platinum Ring Monitor--
freeslotTV("PLATINUM", "PLATINUM")
freeslot(
"SPR_PRTV",
"sfx_plat"
)

--Thunder Shield--
freeslotTV("THUNDER", "THDR")
freeslot(
"S_THUND_ORB1",
"S_THUND_ORB2",
"S_THUND_ORB3",
"S_THUND_ORB4",
"S_THUND_ORB5",
"S_THUND_ORB6",
"S_THUND_ORB7",
"S_THUND_ORB8",
"S_THUND_ORB9",
"S_THUND_ORB10",
"S_THUND_ORB11",
"S_THUND_ORB12",
"S_THUND_ORB13",
"S_THUND_ORB14",
"S_THUND_ORB15",
"S_THUND_ORB16",
"S_THUND_ORB17",
"S_THUND_ORB18",
"S_THUND_ORB19",
"SPR_TDSH",
"SPR_THDR",
"SPR_TUPA",
"sfx_thndr",
"S_THUND",
"S_THUND2",
"S_THUND3",
"MT_THUNDERSPARK",
"S_THUNDERSPARK",
"S_THUNDERSPARK1",
"S_THUNDERSPARK2",
"S_THUNDERSPARK3",
"S_THUNDERSPARK4",
"S_THUNDERSPARK5",
"S_THUNDERSPARK6",
"S_THUNDERSPARK7",
"S_THUNDERSPARK8",
"S_THUNDERSPARK9",
"S_THUNDERSPARK10",
"S_THUNDERSPARK11",
"S_THUNDERSPARK12",
"S_THUNDERSPARK13",
"S_THUNDERSPARK14"
)

--Bumper Shield--
freeslotTV("BUMPER", "BUMPER")
freeslot(
"S_BUMP_ORB1",
"S_BUMP_ORB2",
"S_BUMP_ORB3",
"S_BUMP_ORB4",
"S_BUMP_ORB5",
"S_BUMP_ORB6",
"S_BUMP_ORB7",
"S_BUMP_ORB8",
"S_BUMP_ORB9",
"S_BUMP_ORB10",
"S_BUMP_ORB11",
"S_BUMP_ORB12",
"SPR_BPTV",
"SPR_BUMP"
)

--Pizza Monitor--
freeslotTV("PIZZA", "PIZZA")
freeslot(
"MT_THEPIZZAISAGGRESSIVE",
"S_THEPIZZAISAGGRESSIVE",
"SPR_PIZZ",
"sfx_pizagg",
"sfx_pizza",
"SPR_PIZA",
"MT_PIZZA",
"S_PIZZA",
"SPR_PIIZ"
)

--Welsh Dragon Monitor--
freeslotTV("EXPLOSION", "EXPLOSION")
freeslot(
"sfx_explos",
"sfx_boost",
"sfx_over",
"sfx_nodrag",
"SPR_FRAG",
"MT_WDNXPL",
"SPR_EXPL",
"SPR_OXPL",
"sfx_sexi",
"sfx_sexiki",
"MT_DRAGONEXPL",
"S_DRAGONEXPL1",
"S_DRAGONEXPL2",
"S_DRAGONEXPL3",
"S_DRAGONEXPL4",
"S_DRAGONEXPL5",
"S_DRAGONEXPL6",
"S_DRAGONEXPL7",
"S_DRAGONEXPL8",
"S_DRAGONEXPL9",
"S_DRAGONEXPL10",
"S_DRAGONEXPL11",
"S_DRAGONEXPL12",
"S_DRAGONEXPL13",
"S_DRAGONEXPL14",
"S_DRAGONEXPL15",
"S_DRAGONEXPL16",
"S_DRAGONEXPL17",
"S_DRAGONEXPL18",
"S_DRAGONEXPL19",
"S_DRAGONEXPL20",
"S_DRAGONEXPL21"
)

--Titanium Shield--
freeslotTV("TITANIUM", "TITA")
freeslot(
"S_TITA_ORB1",
"S_TITA_ORB2",
"S_TITA_ORB3",
"S_TITA_ORB4",
"S_TITA_ORB5",
"S_TITA_ORB6",
"S_TITA_ORB7",
"S_TITA_ORB8",
"sfx_titan",
"sfx_titanh",
"S_TITA_ORB9",
"S_TITA_ORB10",
"SPR_TITA",
"SPR_TITS",
"sfx_BLOCKED",
"S_BLOCKED1",
"S_BLOCKED2",
"S_BLOCKED3",
"S_BLOCKED4",
"S_BLOCKED5"
)

--Web Shield--
freeslotTV("WEEB", "WEEB")
freeslot(
"SPR_WEEB",
"SPR_WEBS",
"sfx_crit",
"S_CRIT1",
"S_CRIT2",
"S_CRIT3",
"S_CRIT4",
"S_CRIT5"
)
for i = 1,24
	freeslot("S_WEEB_ORB"..i)
end
for i = 1,6
	freeslot("sfx_weeb"..i)
end

--Earth Shield--
freeslotTV("DIG", "DIG")
freeslot(
"SPR_EART",
"SPR_EARS",
"sfx_dig"
)
for i = 1,12
	freeslot("S_DIG_ORB"..i)
end

--Crumble FOF Monitor--
freeslotTV("FOF", "FOF")
freeslot(
"SPR_FOFM",
"sfx_crum"
)

--Pancake Monitor--
freeslotTV("PANCAKE", "PANCAKE")
freeslot(
"SPR_PAMT",
"sfx_pcake"
)

--Expand Monitor--
freeslotTV("EXPAND", "EXPAND")
freeslot(
"SPR_EXMT",
"sfx_dong"
)

--Goop FOF Monitor--
freeslotTV("GOOP", "GOOP")
freeslot(
"SPR_GPMT",
"sfx_goop"
)

--Eclipse Monitor--
freeslotTV("ECLIPSE", "ECLIPSE")
freeslot(
"SPR_ECMT",
"sfx_eih1",
"sfx_eih2"
)

--Turbo Monitor--
freeslotTV("TURBO", "TURBO")
freeslot(
"SPR_TURB",
"sfx_turbo",
"S_BLUEFIRE",
"SPR_BFLM"
)

--Megidolaon Monitor--
freeslotTV("MEGIDOLAON", "MEGIDOLAON")
freeslot(
"SPR_MEGI",
"sfx_megid1",
"sfx_megid2",
"sfx_megid3",
"sfx_megid0",
"SPR_GARU",
"SPR_DBUF",
"S_DBUFF1",
"S_DBUFF2",
"S_DBUFF3",
"S_DBUFF4",
"S_DBUFF5",
"S_DBUFF6",
"sfx_fire2"
)

--Heavy Gravity Monitor--
freeslotTV("HEAVYGRAV", "HEAVYGRAV")
freeslot(
"SPR_HVGR"
)

--Low Gravity Monitor--
freeslotTV("LOWGRAV", "LOWGRAV")
freeslot(
"SPR_LOGR"
)

--BATKAN!!! Monitor--
freeslotTV("BATKAN", "BATKAN")
freeslot(
"SPR_BAKN",
"sfx_batkan",
"S_KANPART1",
"S_KANPART2",
"S_KANPART3",
"S_KANPART4",
"S_KANPART5",
"S_KANPART6",
"S_KANPART7",
"MT_KANPARTICLE",
"SPR_KANP"
)

--Fitness Monitor--
freeslotTV("FITNESS", "FITNESS")
freeslot(
"SPR_FIMT",
"sfx_fit",
"MT_MASON",
"S_MASON",
"SPR_MASO",
"sfx_fitage",
"sfx_mason1",
"sfx_mason2",
"sfx_mason3",
"sfx_mason4",
"MT_FITNESSPARTICLE",
"S_FITNESSPART1",
"S_FITNESSPART2",
"S_FITNESSPART3",
"S_FITNESSPART4",
"SPR_FIPT"
)

--Blooper Monitor--
freeslotTV("BLOOPER", "BLOOPER")
freeslot(
"SPR_BLOP",
"MT_DRIBPARTICLE",
"S_DRIBPART1",
"S_DRIBPART2",
"S_DRIBPART3",
"S_DRIBPART4",
"SPR_DRIB"
)

--Regeneration Monitor--
freeslotTV("REGEN", "REGEN")
freeslot(
"SPR_REGE",
"sfx_regen",
"MT_REGENPARTICLE",
"S_REGENPART1",
"S_REGENPART2",
"S_REGENPART3",
"S_REGENPART4",
"SPR_REGP"
)

--Blue Shell Monitor--
freeslotTV("BSHELL", "BSHELL")
freeslot(
"SPR_SHEL",
"MT_BLUESHELL",
"sfx_shell",
"MT_BLUXPL",
"SPR_OXPL",
"sfx_megid3"
)
for i = 1,21
	freeslot("S_BLUXPL"..i)
end
for i = 1,5
	freeslot("S_SHELL"..i)
end

--Hyper Sneakers---
freeslotTV("HYPERSHOES", "HSHO")
freeslot(
"SPR_HSHO"
)

--Juggernaut Drive--
freeslotTV("JDRIVE", "JDRIVE")
freeslot(
"sfx_jdrive",
"sfx_breast",
"sfx_grabdr",
"sfx_nodra2",
"sfx_nodra3",
"sfx_divide",
"sfx_lngins",
"SPR_JGDR"
)

--Sentry Monitor--
freeslotTV("SENTRY", "SENTRY")
freeslot(
"SPR_SENT", 
"S_SENTRY",
"S_SENTRY1",
"S_SENTRY2",
"sfx_sentry",
"sfx_psntry",
"MT_SENTRY"
)

for i = 1,5
	freeslot("S_SENTRYPOP"..i)
end

--Pleb Monitor--
freeslotTV("PLEB", "PLEB")
freeslot("sfx_haaaa", "sfx_werror", "SPR_PLEB")

--Fiber Lost Monitor--
freeslotTV("FIBERLOST", "FIBER")
freeslot("SPR_FBMT", "sfx_fbrls")

--Flip Test--
freeslotTV("ULTGRAV", "ULTGRAV")
freeslot("sfx_flip", "sfx_fled")