function A_FireRate(actor)
    local p = actor.target.player
	MP_giveEffect(p, ef_firerate)
end

local firerate_data = {
	time = 700,
	func = function(mo, inflictor, time)
			mo.player.weapondelay = min($, 1)	-- spam projectiles
			local firepart = MP_spawnParticles(mo, MT_FIREPARTICLE)
			if firepart
				firepart.destscale = 1
				firepart.fuse = 30
			end
		end,
	get = function(mo) S_StartSound(mo, sfx_firera) end,
	lose = function(mo)
				mo.color = mo.player.skincolor
				mo.colorized = false
			end,
	hudico = "FRICON",
}
effectList[ef_firerate] = firerate_data

MP_buildMonitor(MT_FIREMONITOR, MT_FIREICON, S_FIRRTV, S_FIRRPOP1, SPR_FIRR, SPR_FIRR, A_FireRate)

states[S_FIREPART1] = {SPR_FIRP, A, 2, nil, 0, 0, S_FIREPART2}
states[S_FIREPART2] = {SPR_FIRP, TR_TRANS30|A, 2, nil, 0, 0, S_FIREPART3}
states[S_FIREPART3] = {SPR_FIRP, TR_TRANS60|A, 2, nil, 0, 0, S_FIREPART4}
states[S_FIREPART4] = {SPR_FIRP, TR_TRANS90|A, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_FIREPARTICLE] = {
	doomednum = -1,
    spawnstate = S_FIREPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}