function A_Invisible(actor)
    local p = actor.target.player
	MP_giveEffect(p, ef_invisible)
end

local function efct_invis(mo, inflictor, time)
	local p = mo.player
	if p == lp
		if leveltime%2
		and not mo.dig_diggingtimer	-- special dig shield check
			removealltransflags(mo)
			mo.frame = $|FF_TRANS50
			mo.flags2 = $ & ~(MF2_DONTDRAW)
			
			if p.followmobj and p.followmobj.valid
				removealltransflags(p.followmobj)
				p.followmobj.frame = $|FF_TRANS50
				p.followmobj.flags2 = $ & ~(MF2_DONTDRAW)			
			end
			
		else
			mo.flags2 = $|MF2_DONTDRAW
			if p.followmobj and p.followmobj.valid
				p.followmobj.flags2 = $|MF2_DONTDRAW		
			end			
		end
	else
		mo.flags2 = $|MF2_DONTDRAW
		if p.followmobj and p.followmobj.valid
			p.followmobj.flags2 = $|MF2_DONTDRAW		
		end			
	end
end

local invis_data = {
	time = 20*TICRATE,
	func = efct_invis,
	get = function(mo) S_StartSound(mo, sfx_s3kb8) end,
	lose = function(mo)
				removealltransflags(mo)
				mo.flags2 = $ & ~MF2_DONTDRAW
				if mo.player.followmobj and mo.player.followmobj.valid
					mo.player.followmobj.flags2 = $ & ~MF2_DONTDRAW
				end
				S_StartSound(mo, sfx_s3kb8)
			end,
	hudico = "INICON",
}
effectList[ef_invisible] = invis_data

-- make vanilla shields invisible

local function MP_invis_overlay_think(mo)
	
	local t = mo.target
	if t and not t.player	-- armageddon shield
		t = t.target
	end	
	
	if mo and t and t.valid and t.player and t.MP_effects
		if t.MP_effects[ef_invisible] >= 1
			mo.flags2 = $|MF2_DONTDRAW
			if mo.tracer and mo.tracer.valid
				mo.tracer.flags2 = $|MF2_DONTDRAW
			end	-- elemental shield	
			
		elseif mo.flags2 & MF2_DONTDRAW
			mo.flags2 = $ & ~MF2_DONTDRAW
			if mo.tracer and mo.tracer.valid
				mo.tracer.flags2 = $|MF2_DONTDRAW
			end	
		end
	end
end

addHook("MobjThinker", MP_invis_overlay_think, MT_OVERLAY)
addHook("MobjThinker", MP_invis_overlay_think, MT_ELEMENTAL_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_ATTRACT_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_FORCE_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_ARMAGEDDON_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_WHIRLWIND_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_PITY_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_FLAMEAURA_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_BUBBLEWRAP_ORB)
addHook("MobjThinker", MP_invis_overlay_think, MT_THUNDERCOIN_ORB)

MP_buildMonitor(MT_INVISMONITOR, MT_INVISICON, S_INVISTV, S_INVISPOP1, SPR_INVI, SPR_INVI, A_Invisible)