local eclipse_dta = {
	icon = "ECLIPICO",
	timer = TICRATE*15,
	start = function()
				S_StartSound(nil, sfx_eih2)
				for s in sectors.iterate do
					if s and s.valid
						s.lightlevel = server.MP_savesectors[#s].lightlevel*11/20
					end
				end
				P_SetupLevelSky(669)
			end,
	stop = 	function()
				S_StartSound(nil, sfx_eih1)
				for s in sectors.iterate do
					if s and s.valid
						s.lightlevel = server.MP_savesectors[#s].lightlevel
					end
				end
				server.sector_savelightlevel = nil
				P_SetupLevelSky(mapheaderinfo[gamemap].skynum, nil)
			end,
}
geffectList[gef_eclipse] = eclipse_dta

function A_Eclipse(actor)
	MP_addGlobalEffect(gef_eclipse)
end

MP_buildMonitor(MT_ECLIPSEMONITOR, MT_ECLIPSEICON, S_ECLIPSETV, S_ECLIPSEPOP1, SPR_ECMT, SPR_ECMT, A_Eclipse)