-- TODO: optimize that shitty hit func
local esp_rechargeTics = TICRATE*3/2

function A_ESPShield(actor)
	if not actor.target or not actor.target.player
		print("ERROR: A_ESPShield: Power up has no target.")
		return
	end
	local p = actor.target.player
	MP_giveShield(p, SH_ESPSHIELD)
end

local function espGet(mo)
	-- remove any existing recharging timer
	mo.esp_rechargetimer = nil
end

local function espReflect(mo, inflictor, source)
	if mo.player and mo.player.powers[pw_super] return end
	if inflictor and inflictor.flags & MF_MISSILE
		if not ((inflictor.flags2 & MF2_RAILRING) and source and source.valid)	-- wow its not a rail? doing good sam
			S_StartSound(nil, sfx_reflec, mo.player)
			local returnto = P_SpawnMobj(mo.x, mo.y, mo.z, inflictor.type)
			returnto.momx = -inflictor.momx*3
			returnto.momy = -inflictor.momy*3
			returnto.momz = -inflictor.momz*3
			returnto.angle = inflictor.angle+ANGLE_180
			returnto.target = mo
		else	-- i knew that was a lie
			
			source.MP_nohurtmsg = true
			P_AddPlayerScore(source.player, 50)
			P_DamageMobj(source)
			P_InstaThrust(source, inflictor.angle, -75*FRACUNIT)
			S_StartSound(nil, sfx_rail2, source.player)
			S_StartSound(nil, sfx_reflec, source.player)
			S_StartSound(nil, sfx_reflec, mo.player)
			source.MP_nohurtmsg = false
			
			if source.health or source.player and source.player.powers[pw_shield]
			and not source.player and (source.player.powers[pw_invulnerability] or source.player.powers[pw_flashing] or source.player.powers[pw_shield] == SH_TITANIUM)
				P_AddPlayerScore(mo.player, 50)
				if (source.player.name == "SAMMY_SWAG" or source.player.name == "Spectorious")
					print("Yeah fuck you too Sam")
				else
					print(source.player.cname.." was damaged by "..mo.player.cname.."'s reflected Rail Ring! That's karma for you!")
				end
			else	-- well you can go eat a dick
				P_AddPlayerScore(mo.player, 100)
				if (source.player.name == "SAMMY_SWAG" or source.player.name == "Spectorious")
					print("Sammy lost his virginity to his own reflected rail ring.")
				else
					print(source.player.cname.." was killed by "..mo.player.cname.."'s reflected Rail Ring! Nobody liked you.")
				end
			end
		end
	end
end


local function espThink(mo)
	-- handle recharge + transparency of the orb
	if (mo.esp_rechargetimer)
		local orb = mo.MP_shieldorb
		
		if not (orb.flags2 & MF2_DONTDRAW)
			local trans_add = (1 + ((mo.esp_rechargetimer * 4)/esp_rechargeTics))
			local trans = 5 + trans_add
			orb.frame = ($ & ~(FF_TRANSMASK))|(trans << FF_TRANSSHIFT)
		end
		
		mo.esp_rechargetimer = $-1
		if not (mo.esp_rechargetimer)
			mo.esp_rechargetimer = nil
			orb.frame = ($ & ~(FF_TRANSMASK))|TR_TRANS50
			S_StartSound(mo, sfx_appear)
		end
	end
end

local function espSpecial(mo)
	local p = mo.player
	
	-- multiplier stuff
	local multiplier = FRACUNIT
	if (mo.esp_rechargetimer)
		-- reduce strengh of the special
		local min_multiplier = FRACUNIT/5
		
		multiplier = $ - ((mo.esp_rechargetimer * (FRACUNIT - min_multiplier))/esp_rechargeTics)
	end
	
	-- push stuff away from you
	local range = FixedMul(multiplier, 64*FRACUNIT)
	local strength = FixedMul(multiplier, 512*FRACUNIT)
	P_Telekinesis(p, range, strength)
	
	-- reflect projectiles
	local height = FixedMul(multiplier, 256*FRACUNIT)
	for mobj in mobjs.iterate()
		if not (mobj.flags & MF_MISSILE) then continue end
		if (mobj.target == mo) then continue end
		
		if (R_PointToDist2(mobj.x, mobj.y, mo.x, mo.y) <= range)
		and (abs(mo.z - mobj.z) <= height)
			mobj.target = mo
			mobj.angle = $ + ANGLE_180
			mobj.momx, mobj.momy, mobj.momz = -$*2, -$*2, -$*2
		end
	end
	
	-- visuals
	local speed = FixedMul(multiplier, 80*FRACUNIT)
	local scale = FixedMul(multiplier, mo.scale)
	
	for i = 1, 16
		local dust = P_SpawnMobj(mo.x, mo.y, mo.z + (P_GetPlayerHeight(p)/2), MT_THOK)
		dust.angle = ANGLE_90 + ANG1* (22*(i-1))
		P_InstaThrust(dust, dust.angle, speed)
		dust.frame = A
		dust.momx = $+mo.momx
		dust.momy = $+mo.momy
		dust.scale = scale
		dust.destscale = 1
		dust.color = i%2 and SKINCOLOR_PINK or SKINCOLOR_YELLOW
	end
	
	p.pflags = $|(PF_THOKKED|PF_SHIELDABILITY)
	mo.esp_rechargetimer = esp_rechargeTics
	S_StartSound(mo, sfx_s3k74)
	return true
end

local esp_data = {
	orbstate = S_ESP_ORB1,
	hudico = "ESPICO",
	sound = sfx_s3k74,
	get = espGet,
	func = espThink,
	special = espSpecial,
	hit = espReflect,
}
shieldList[SH_ESPSHIELD] = esp_data

MP_buildMonitor(MT_ESPMONITOR, MT_ESPICON, S_ESPTV, S_ESPPOP1, SPR_ESPT, SPR_ESPT, A_ESPShield)

states[S_ESP_ORB1] = {SPR_ESPS, A|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB2}
states[S_ESP_ORB2] = {SPR_ESPS, B|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB3}
states[S_ESP_ORB3] = {SPR_ESPS, C|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB4}
states[S_ESP_ORB4] = {SPR_ESPS, D|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB5}
states[S_ESP_ORB5] = {SPR_ESPS, E|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB6}
states[S_ESP_ORB6] = {SPR_ESPS, F|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB7}
states[S_ESP_ORB7] = {SPR_ESPS, G|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB8}
states[S_ESP_ORB8] = {SPR_ESPS, H|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB9}
states[S_ESP_ORB9] = {SPR_ESPS, I|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB10}
states[S_ESP_ORB10] = {SPR_ESPS, J|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB11}
states[S_ESP_ORB11] = {SPR_ESPS, K|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB12}
states[S_ESP_ORB12] = {SPR_ESPS, L|TR_TRANS50, 2, nil, 0, 0, S_ESP_ORB1}