-- i honestly cba to rewrite manimi's script. it's really messy and unholy but it works so i'm not gonna nitpick
freeslot("sfx_crit", "S_CRIT1", "S_CRIT2", "S_CRIT3", "S_CRIT4", "S_CRIT5", "MT_WEEBMONITOR")

states[S_CRIT1] = {SPR_WEEB, F, 55, nil, 0, 0, S_CRIT2}
states[S_CRIT2] = {SPR_WEEB, F|TR_TRANS20, 4, nil, 0, 0, S_CRIT3}
states[S_CRIT3] = {SPR_WEEB, F|TR_TRANS40, 4, nil, 0, 0, S_CRIT4}
states[S_CRIT4] = {SPR_WEEB, F|TR_TRANS60, 4, nil, 0, 0, S_CRIT5}
states[S_CRIT5] = {SPR_WEEB, F|TR_TRANS80, 4, nil, 0, 0, S_NULL}
for i = 1,5
	freeslot("sfx_weeb"..i)
end

function A_WeebShield(actor)
	if not actor.target or not actor.target.player
		print("ERROR: A_WeebShield: Power up has no target.")
		return
	end

	local p = actor.target.player
	local mo = p.mo

	MP_giveShield(p, SH_WEBSHIELD)
end

--==Hook-Ring! By ManimiFire==--

local hookring = true
local playerscatch = false

freeslot("MT_PLAYERCHAIN", "MT_NORMALCHAIN", "S_PLAYERCHAIN", "S_NORMALCHAIN", "SPR_WESS", "SPR_WEBB")

mobjinfo[MT_PLAYERCHAIN] = {
	spawnstate = S_PLAYERCHAIN,
	height = 4*FRACUNIT,
    flags = MF_STICKY
}

mobjinfo[MT_NORMALCHAIN] = {
	spawnstate = S_NORMALCHAIN,
	height = 10*FRACUNIT,
	radius = 10*FRACUNIT,
	flags = MF_NOCLIPHEIGHT
}


states[S_PLAYERCHAIN] = {SPR_WEBB, A, 1, nil, 0, 0, S_PLAYERCHAIN}
states[S_NORMALCHAIN] = {SPR_WESS, A, 1, nil, 0, 0, S_NORMALCHAIN}

local chain
local targett
local distt = 1500<<FRACBITS
local crings = {}
local ccount = 0

local function initCombiLoop()
	ccount = 0
end

local function drawCombiRing(x,y,z)
	ccount = $1+1
	if crings[ccount] and crings[ccount].valid then
	      P_TeleportMove(crings[ccount], x, y, z)
    else
		crings[ccount] = P_SpawnMobj(x, y, z, MT_NORMALCHAIN)
		crings[ccount].scale = FRACUNIT
	end
	crings[ccount].fuse = 2
end

local function attachPlayers(chain)
	-- Draw combi rings
	for i=1,7 do
	if chain.target ~= nil
		drawCombiRing(
			chain.target.x+(chain.x-chain.target.x)*i/8,
			chain.target.y+(chain.y-chain.target.y)*i/8,
			chain.target.z+(chain.z-chain.target.z)*i/8
		)
	end
	end
end
addHook("MobjThinker", attachPlayers, MT_PLAYERCHAIN)

/*local function throwHook(mo)

end*/

local function weebthink(mo)

	local p = mo.player
	local player = p

	if player.readyready == nil
		player.readyready = false
	end
	if player.recovery == nil
		player.recovery = 0
	end
	if player.hang == nil
		player.hang = false
	end
	if player.recovery > 0
		player.recovery = $1 - 1
	end
	if player.hookring == nil
		player.hookring = true
	end
		
	if mo.eflags & MFE_UNDERWATER
		MP_loseShield(p, true)
		S_StartSound(player.mo, sfx_weeb6)		
	end
end

local function weebSpecial(mo)
	local p = mo.player
	if (p.recovery != 0) then return true end
	
	-- shoot the web
	local an = mo.angle
	local slope = p.aiming
	local speed = 96*FRACUNIT + p.speed
	
	chain = P_SpawnMobj(mo.x, mo.y, mo.z+6*FRACUNIT, MT_PLAYERCHAIN)
	chain.state = S_THOK
	chain.tics = -1
	chain.frame = A
	chain.color = SKINCOLOR_WHITE
	chain.scale = FRACUNIT
	chain.target = mo
	chain.angle = an
	chain.momx = FixedMul(speed, cos(an))
	chain.momy = FixedMul(speed, sin(an))
	chain.momx = FixedMul(chain.momx, cos(slope))
	chain.momy = FixedMul(chain.momy, cos(slope))
	chain.momz = FixedMul(speed, sin(slope))
	chain.ready = false
		
	-- adjust the player
	//p.pflags = $|(PF_THOKKED|PF_SHIELDABILITY)
	p.readyready = true
	mo.target = chain
	S_StartSound(mo, _G["sfx_weeb"..P_RandomRange(2, 4)])
	return true
end

local weeb_data = {
	orbstate = S_WEEB_ORB1,
	hudico = "WEEBICO",
	sound = sfx_weeb1,
	func = weebthink,
	special = weebSpecial,
}
shieldList[SH_WEBSHIELD] = weeb_data

addHook("MobjThinker", function(chain)

	if chain and chain.valid
		chain.sprite = SPR_WEBB
		chain.frame = A
		chain.color = SKINCOLOR_WHITE
	end

	chain.atwall = 0
	local distt = 1024<<FRACBITS + (chain.target.player.speed)
	local disttt = 1256<<FRACBITS + (chain.target.player.speed)
	local dist = 1256<<FRACBITS + (chain.target.player.speed)
	local factor = FRACUNIT>>8

	-- do not let it grab onto skies or thok barriers, like what the fuck lol
	if chain.valid
		if ((chain.z+chain.height)/FRACUNIT) >= (chain.ceilingz/FRACUNIT) - 32	-- grabbing on ceiling
		and chain.subsector.sector.ceilingpic:find("SKY1")	--... on sky.
		and chain.ceilingz == chain.subsector.sector.ceilingheight	-- mind FOFs
			chain.target.player.readyready = false
			chain.grabbing = false
			P_RemoveMobj(chain)
			return
		end

		local l = MP_nearestLine(chain, chain.subsector.sector.lines)
		if l and l.frontsector and l.backsector
			if l.frontsector == chain.subsector.sector
				if chain.z >= l.backsector.ceilingheight
				and l.backsector.ceilingpic:find("F_SKY1")
					chain.target.player.readyready = false
					chain.grabbing = false
					P_RemoveMobj(chain)
					return
				end
			else
				if chain.z >= l.frontsector.ceilingheight
				and l.frontsector.ceilingpic:find("F_SKY1")
					chain.target.player.readyready = false
					chain.grabbing = false
					P_RemoveMobj(chain)
					return
				end
			end
		end
	end

	if chain.valid
	and chain.target == nil
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.target ~= nil
	and chain.target.player.playerstate == PST_DEAD
		chain.target.player.readyready = false
		chain.grabbing = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.tracer
	and chain.tracer.player
	and chain.tracer.player.playerstate == PST_DEAD
		chain.target.player.readyready = false
		chain.grabbing = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and (chain.target.player.hookring == false or hookring == false)
		chain.target.player.readyready = false
		chain.grabbing = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.hangtime == nil
	   chain.hangtime = 0
	end
	
	if chain.valid
	and chain.goingback == nil
		chain.goingback = false
	end
	
	if chain.valid
	and P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z) >= distt
		chain.goingback = true
	end
	
	if chain.valid
	and chain.goingback == true
		local xdist = chain.target.x-chain.x
		local ydist = chain.target.y-chain.y
		local zdist = chain.target.z-chain.z
		xdist = FixedMul($1, factor)
		ydist = FixedMul($1, factor)
		zdist = FixedMul($1, factor)
		
		chain.momx = $1+xdist*3
		chain.momy = $1+ydist*3
		chain.momz = $1+zdist*3
	end
	
	if chain.valid
	and chain.goingback == true
	and abs(chain.z - chain.target.z)<= chain.target.height
	and R_PointToDist2(chain.x, chain.y, chain.target.x, chain.target.y)<= 40*FRACUNIT
		chain.grabbing = false
		chain.target.player.readyready = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
		if (chain.eflags & MFE_JUSTHITFLOOR) or (abs((chain.z + chain.height) - chain.floorz) < 8*chain.scale) or (abs((chain.z + chain.height) - chain.ceilingz) < 8*chain.scale) or (P_IsObjectOnGround(chain))
			chain.momz = 0
			chain.momx = 0
			chain.momy = 0
			chain.ready = true
			chain.hangtime = $1 + 1
			
			if chain.hangtime == 1 then
				chain.currentdist = P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z)
			end
		end
	end
   
	if chain.valid
	and chain.target == nil
	and chain.grabbing == true
		chain.grabbing = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.tracer
	and chain.tracer.player
	and chain.tracer == nil
	and chain.grabbing == true
		chain.grabbing = false
		chain.target.player.readyready = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.tracer
	and (chain.tracer.flags & MF_ENEMY or chain.tracer.flags & MF_BOSS)
	and chain.tracer.health == 0
	and chain.grabbing == true
		chain.grabbing = false
		chain.target.player.readyready = false
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.validness == nil
		chain.validness = 0
	end
	
	if chain.valid
		if chain.momz == 0
		and chain.momx == 0
		and chain.momy == 0
		and chain.validness > 1
			chain.target.speed = 2*FRACUNIT
			chain.momz = 0
			chain.momx = 0
			chain.momy = 0
			chain.ready = true
			chain.hangtime = $1 + 1
			
			if chain.hangtime == 1 then
				chain.currentdist = P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z)
			end
		end
	end
	
	if chain.valid
		if chain.ready == true
			if P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z) > chain.currentdist
				local xdist = chain.target.x-chain.x
				local ydist = chain.target.y-chain.y
				local zdist = chain.target.z-chain.z
				xdist = FixedMul($1, factor)
				ydist = FixedMul($1, factor)
				zdist = FixedMul($1, factor)
				
				chain.target.speed = 2*FRACUNIT
				chain.momz = 0
				chain.momx = 0
				chain.momy = 0
				chain.target.momx = $1-xdist
				chain.target.momy = $1-ydist
				chain.target.momz = $1-zdist
				
				chain.target.player.pflags = ($ & ~(PF_JUMPED|PF_SPINNING)) | (PF_THOKKED|PF_SHIELDABILITY)
				chain.target.state = S_PLAY_RIDE
			end
		end
	end
	
	if chain.valid
		if chain.tracer ~= nil
		and chain.ready == true
		and (chain.target.player.cmd.buttons & BT_CUSTOM3)
			local xdist = chain.target.x-chain.x
			local ydist = chain.target.y-chain.y
			local zdist = chain.target.z-chain.z
			xdist = FixedMul($1, factor)
			ydist = FixedMul($1, factor)
			zdist = FixedMul($1, factor)
				
			chain.tracer.momx = $1+xdist
			chain.tracer.momy = $1+ydist
			chain.tracer.momz = $1+zdist
		end
	end
	
	if chain.valid
		if chain.ready == true
			local xdist = chain.target.x-chain.x
			local ydist = chain.target.y-chain.y
			local zdist = chain.target.z-chain.z
			xdist = FixedMul($1, factor)
			ydist = FixedMul($1, factor)
			zdist = FixedMul($1, factor)
			
			chain.target.momx = $1-xdist
			chain.target.momy = $1-ydist
			chain.target.momz = $1-zdist
			chain.hangtime = 0
			
			chain.target.player.pflags = ($ & ~(PF_JUMPED|PF_SPINNING)) | (PF_THOKKED|PF_SHIELDABILITY)
			chain.target.state = S_PLAY_RIDE
		end
	end
	
	if chain.valid
	and chain.rest == nil
		chain.rest = 0
	end
	
	if chain.valid
		if chain.validness == nil
			chain.validness = 0
		elseif chain.validness ~= nil
			chain.validness = $1 + 1
		elseif chain.grabbing == nil
			chain.grabbing = false
		end
	end

	if chain.valid
	and chain.target.valid
	and P_IsObjectOnGround(chain.target)
	and (not (chain.target.player.cmd.buttons & BT_USE) or chain.target.eflags & MFE_UNDERWATER or not chain.target.player.powers[pw_shield])
	and chain.validness > 1
		chain.target.player.readyready = false
		chain.grabbing = false
		chain.target.player.recovery = 2
		S_StartSound(chain.target, sfx_weeb5)
		P_RemoveMobj(chain)
	end
	
	if chain.valid
	and chain.target.valid
	and not P_IsObjectOnGround(chain.target)
	and not (chain.target.player.cmd.buttons & BT_USE)
	and chain.validness > 1
		if chain.ready == true
			chain.target.state = ((chain.target.momz * P_MobjFlip(chain.target)) > 0) and S_PLAY_SPRING or S_PLAY_FALL
		end
		
		chain.target.player.readyready = false
		chain.target.player.recovery = 2
		chain.grabbing = false
		S_StartSound(chain.target, sfx_weeb5)
		P_RemoveMobj(chain)
	end
end, MT_PLAYERCHAIN)

addHook("MobjMoveCollide", function(chain, targett)
	if targett and chain.valid
		if (targett.flags & MF_ENEMY or targett.flags & MF_BOSS or targett.flags & MF_SOLID or targett.flags & MF_MONITOR)
		and not targett.player
		and chain.target
		and chain.target ~= targett
		and P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z) < distt
		and abs(chain.z - targett.z)<= targett.height
			chain.tracer = targett
			chain.grabbing = true
		end
	end
end, MT_PLAYERCHAIN)

addHook("MobjMoveCollide", function(chain, targett)
	if targett and chain.valid
		if (targett.player)
			if playerscatch == true
			and chain.target
			and chain.target ~= targett
			and P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z) < distt
			and abs(chain.z - targett.z)<= targett.height
				chain.tracer = targett
				chain.grabbing = true
			end
		end
	end
end, MT_PLAYERCHAIN)

addHook("MobjThinker", function(chain)
	if chain.valid
	and chain.tracer
	and chain.tracer ~= nil
	and chain.grabbing == true
		P_TeleportMove(chain, chain.tracer.x, chain.tracer.y, chain.tracer.z)
		chain.hangtime = $1 + 1
		chain.ready = true
		chain.momz = 0
		chain.momx = 0
		chain.momy = 0
		
		if chain.hangtime == 1 then
			chain.currentdist = P_AproxDistance(P_AproxDistance(chain.target.x-chain.x, chain.target.y-chain.y) ,chain.target.z-chain.z)
		end
	end
end, MT_PLAYERCHAIN)

addHook("MobjDamage", function(p, inflictor, source)
	if not p.target then return false end
	
	if p.target.type == MT_PLAYERCHAIN
		p.player.readyready = false
		p.target.grabbing = false
		P_RemoveMobj(p.target)
	end
end)

addHook("PlayerSpawn", function(player)
	for player in players.iterate
		if player.mo
		and player.jointime == 0
			player.readyready = false
			player.hang = false
			player.recovery = 0
		end
	end
end)

addHook("PlayerSpawn", function(player)
	for player in players.iterate
		if player.mo
			player.readyready = false
			player.hang = false
			player.recovery = 0
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.mo
		and player.spectator == true
			player.readyready = false
			player.hang = false
			player.recovery = 0
		end
	end
end)

for i = 1,24
	freeslot("S_WEEB_ORB"..i)
end

MP_buildMonitor(MT_WEEBMONITOR, MT_WEEBICON, S_WEEBTV, S_WEEBPOP1, SPR_WEEB, SPR_WEEB, A_WeebShield)

states[S_WEEB_ORB1] = {SPR_WEBS, A|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB2}
states[S_WEEB_ORB2] = {SPR_WEBS, B|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB3}
states[S_WEEB_ORB3] = {SPR_WEBS, C|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB4}
states[S_WEEB_ORB4] = {SPR_WEBS, D|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB5}
states[S_WEEB_ORB5] = {SPR_WEBS, E|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB6}
states[S_WEEB_ORB6] = {SPR_WEBS, F|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB7}
states[S_WEEB_ORB7] = {SPR_WEBS, G|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB8}
states[S_WEEB_ORB8] = {SPR_WEBS, H|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB9}
states[S_WEEB_ORB9] = {SPR_WEBS, I|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB10}
states[S_WEEB_ORB10] = {SPR_WEBS, J|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB11}
states[S_WEEB_ORB11] = {SPR_WEBS, K|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB12}
states[S_WEEB_ORB12] = {SPR_WEBS, L|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB13}
states[S_WEEB_ORB13] = {SPR_WEBS, M|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB14}
states[S_WEEB_ORB14] = {SPR_WEBS, N|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB15}
states[S_WEEB_ORB15] = {SPR_WEBS, O|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB16}
states[S_WEEB_ORB16] = {SPR_WEBS, P|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB17}
states[S_WEEB_ORB17] = {SPR_WEBS, Q|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB18}
states[S_WEEB_ORB18] = {SPR_WEBS, R|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB19}
states[S_WEEB_ORB19] = {SPR_WEBS, S|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB20}
states[S_WEEB_ORB20] = {SPR_WEBS, T|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB21}
states[S_WEEB_ORB21] = {SPR_WEBS, U|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB22}
states[S_WEEB_ORB22] = {SPR_WEBS, V|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB23}
states[S_WEEB_ORB23] = {SPR_WEBS, W|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB24}
states[S_WEEB_ORB24] = {SPR_WEBS, X|TR_TRANS20, 2, nil, 0, 0, S_WEEB_ORB1}