function A_ResetPoints(actor)
	if not (actor.target and actor.target.player) then
        return
    end

	local player = actor.target.player

	if P_RandomRange(0, 4) == 0
		S_StartSound(player.mo, sfx_token)
		P_AddPlayerScore(player, 500)
		print(player.cname.." got lucky and received an additional 500 points from a Reset Score monitor!")
	else
		S_StartSound(player.mo, sfx_lose)
		S_StartSound(player.mo, _G["sfx_bewar"..P_RandomRange(1, 4)])
		actor.target.player.score = 0
		print(player.cname.." lost all their points due to a Reset Score monitor... sucks to be them!")
	end
end

MP_buildMonitor(MT_RESETMONITOR, MT_RESETICON, S_RESETTV, S_RESETPOP1, SPR_REST, SPR_REST, A_ResetPoints)